"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __require = typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// src/index.ts
__export(exports, {
  default: () => solidReactivityPlugin
});
var import_helper_module_imports = __toModule(require("@babel/helper-module-imports"));
var t = __toModule(require("@babel/types"));
function getHookIdentifier(hooks, path, name) {
  const current = hooks.get(name);
  if (current) {
    return current;
  }
  const newID = (0, import_helper_module_imports.addNamed)(path, name, "solid-js");
  hooks.set(name, newID);
  return newID;
}
function signalExpression(hooks, path, body) {
  if (!t.isExpressionStatement(body)) {
    throw new Error("Expected expression statement");
  }
  if (!t.isAssignmentExpression(body.expression)) {
    throw new Error("Expected assignment expression");
  }
  if (body.expression.operator !== "=") {
    throw new Error("Invalid assignment expression operator");
  }
  const signalIdentifier = body.expression.left;
  const stateIdentifier = body.expression.right;
  if (!t.isIdentifier(signalIdentifier)) {
    throw new Error("Expected identifier");
  }
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  const expr = t.variableDeclaration("const", [t.variableDeclarator(t.arrayPattern([
    readIdentifier,
    writeIdentifier
  ]), t.callExpression(getHookIdentifier(hooks, path, "createSignal"), [stateIdentifier]))]);
  path.replaceWith(expr);
  const parent = path.getFunctionParent();
  if (parent) {
    parent.traverse({
      Identifier(p) {
        if (!p.scope.hasOwnBinding(signalIdentifier.name) && p.node.name === signalIdentifier.name) {
          p.replaceWith(t.callExpression(readIdentifier, []));
        }
      },
      AssignmentExpression(p) {
        const identifier = p.node.left;
        const expression = p.node.right;
        if (t.isIdentifier(identifier) && !p.scope.hasOwnBinding(signalIdentifier.name) && identifier.name === signalIdentifier.name) {
          const param = p.scope.generateUidIdentifier("current");
          p.replaceWith(t.callExpression(writeIdentifier, [
            t.arrowFunctionExpression([param], t.assignmentExpression(p.node.operator, param, expression))
          ]));
        }
      }
    });
  }
}
function memoExpression(hooks, path, body) {
  if (!t.isExpressionStatement(body)) {
    throw new Error("Expected expression statement");
  }
  if (!t.isAssignmentExpression(body.expression)) {
    throw new Error("Expected assignment expression");
  }
  if (body.expression.operator !== "=") {
    throw new Error("Invalid assignment expression operator");
  }
  const memoIdentifier = body.expression.left;
  const stateIdentifier = body.expression.right;
  if (!t.isIdentifier(memoIdentifier)) {
    throw new Error("Expected identifier");
  }
  const readIdentifier = path.scope.generateUidIdentifier(memoIdentifier.name);
  const expr = t.variableDeclaration("const", [t.variableDeclarator(readIdentifier, t.callExpression(getHookIdentifier(hooks, path, "createMemo"), [
    t.arrowFunctionExpression([], stateIdentifier)
  ]))]);
  path.replaceWith(expr);
  const parent = path.getFunctionParent();
  if (parent) {
    parent.traverse({
      Identifier(p) {
        if (!p.scope.hasOwnBinding(memoIdentifier.name) && p.node.name === memoIdentifier.name) {
          p.replaceWith(t.callExpression(readIdentifier, []));
        }
      }
    });
  }
}
function effectExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body) && t.isArrowFunctionExpression(body.expression)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "createEffect"), [
    callback
  ]));
}
function computedExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body) && t.isArrowFunctionExpression(body.expression)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "createComputed"), [
    callback
  ]));
}
function renderEffectExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body) && t.isArrowFunctionExpression(body.expression)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "createRenderEffect"), [
    callback
  ]));
}
function mountExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body) && t.isArrowFunctionExpression(body.expression)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "onMount"), [
    callback
  ]));
}
function cleanupExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body) && t.isArrowFunctionExpression(body.expression)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "onCleanup"), [
    callback
  ]));
}
function errorExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body) && t.isArrowFunctionExpression(body.expression)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "onError"), [
    callback
  ]));
}
function rootExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body) && t.isArrowFunctionExpression(body.expression)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "createRoot"), [
    callback
  ]));
}
function untrackExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body) && t.isArrowFunctionExpression(body.expression)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "untrack"), [
    callback
  ]));
}
function batchExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body) && t.isArrowFunctionExpression(body.expression)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "batch"), [
    callback
  ]));
}
function solidReactivityPlugin() {
  return {
    pre() {
      this.hooks = new Map();
    },
    visitor: {
      LabeledStatement(path, state) {
        const { label, body } = path.node;
        switch (label.name) {
          case "signal":
            signalExpression(state.hooks, path, body);
            break;
          case "effect":
            effectExpression(state.hooks, path, body);
            break;
          case "computed":
            computedExpression(state.hooks, path, body);
            break;
          case "renderEffect":
            renderEffectExpression(state.hooks, path, body);
            break;
          case "memo":
            memoExpression(state.hooks, path, body);
            break;
          case "mount":
            mountExpression(state.hooks, path, body);
            break;
          case "cleanup":
            cleanupExpression(state.hooks, path, body);
            break;
          case "error":
            errorExpression(state.hooks, path, body);
            break;
          case "untrack":
            untrackExpression(state.hooks, path, body);
            break;
          case "batch":
            batchExpression(state.hooks, path, body);
            break;
          case "root":
            rootExpression(state.hooks, path, body);
            break;
          default:
            break;
        }
      }
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
//# sourceMappingURL=index.js.map
